﻿import pygame
import numpy as np
class spiel(object):
    def __init__(self, scr, pos):
        #self.name=spieler
        self.scr=scr
        self.pos=pos#position in dem fenster
        self.window_size = [400, 400]#feldgroesse initiieren
        self.black = (0, 0, 0)
        self.white = (255, 255, 255)
        self.yellow= (0,255,255)
        self.red = (255, 0, 0)
        self.blue=(255,255,0)
        self.green=(255,0,255)
        self.miss=self.yellow#-2
        self.new=self.red
        self.leer=self.white#0
        self.right=self.blue
        self.hit=self.black#-1
        self.colors=[self.leer,self.hit,self.miss]
        self.MARGIN = 5
        self.WIDTH = self.window_size[0]//10-self.MARGIN#masse eines kaestchens
        self.HEIGHT = self.window_size[1]//10-self.MARGIN
        self.step=1#1->schiffe setzen, 2->schiffe versenken
        self.hits=0#getroffene Pixel
        self.zuege=0#gebrauchte zuege
        self.schiffe=[1,1,1,1]#[4,3,2,1]#Anzahl der Schiffe von 2-5
        self.leben=0
        for x in range(4):
            self.leben+=(x+2)*self.schiffe[x]#anzahl der benoetigten treffer bestimmen
        self.grid = []
        self.grid=np.zeros([10,10],dtype="int") #10x10 array mit nullen
        self.done = True
        self.info=[]#infos ueber das aktuell geklickte schiff
    def start(self):
        self.done = True
       
        self.reset()
        if len(self.schiffe)<=4:#wenn schiffe nicht beim initialisieren eingegeben wurden
            self.input()
            
            print(repr(self.grid))
            print(self.schiffe)
        self.reset()
        ergebnis=self.zug()
        if ergebnis=="win":
            self.right=self.green
            self.printf
            text="Congratulations "+self.name+". \nYou won in "+str(self.zuege)+" steps!!!"
            print(text)
            self.right=self.blue
            return ergebnis
        elif ergebnis=="exit":
            text="Spieler hat das Spiel beendet"
            print(text)
            return ergebnis
        else:
            print("Unerwarteter Fehler:"+str(ergebnis))
            return False
        
        """    
        eingabe=input("again?: y/n")
        if eingabe.upper()==Y:
            self.start()"""
    def exit(self):
        #pygame.quit()
        self.done=False
    def reset(self):#das grid zeichnen
        pygame.draw.rect(self.scr,self.black,[self.pos[0],self.pos[1],self.window_size[0]+self.MARGIN,self.window_size[1]+self.MARGIN])#feld mit schwarz fuellen 
        #        pygame.draw.rect(self.scr,self.black,[self.window_size[0]+ self.pos[0],self.window_size[1]+ self.pos[1],self.window_size[0],self.window_size[1]])#feld mit schwarz fuellen 

        for row in range(10):#kaestchen malen
            for column in range(10):
                pygame.draw.rect(self.scr,
                             self.leer,
                             [(self.MARGIN + self.WIDTH ) * column + self.MARGIN+ self.pos[0],
                              (self.MARGIN + self.HEIGHT) * row + self.MARGIN + self.pos[1],
                              self.WIDTH,
                              self.HEIGHT])

        pygame.display.flip()
    def printf(self):
        #pygame.draw.rect(self.scr,self.black,[self.pos[0],self.pos[1],self.window_size[0]+self.MARGIN,self.window_size[1]+self.MARGIN])#feld mit schwarz fuellen 

        for row in range(10):#kaestchen malen
            for column in range(10):
                self.color=self.leer#kein schiff
                if self.info.count([row,column])>0:
                    self.color=self.new#neues schiff
                if len(self.schiffe)>4:
                    for z in self.schiffe[4:]:
                        if z.count([row,column])>0:
                            self.color=self.right#fertiges schiff
          
                pygame.draw.rect(self.scr,
                             self.color,
                              [(self.MARGIN + self.WIDTH ) * column + self.MARGIN+ self.pos[0],
                              (self.MARGIN + self.HEIGHT) * row + self.MARGIN + self.pos[1],
                              self.WIDTH,
                              self.HEIGHT])

                pygame.display.flip()#aenderungen anzeigen
    def printgrid(self):
        for row in range(10):#kaestchen malen
            for column in range(10):
                print(self.grid)
                
                z= self.grid[row,column]
                print(z*(-1))
                self.color=self.colors[z*(-1)]
                pygame.draw.rect(self.scr,
                             self.color,
                              [(self.MARGIN + self.WIDTH ) * column + self.MARGIN+ self.pos[0],
                              (self.MARGIN + self.HEIGHT) * row + self.MARGIN + self.pos[1],
                              self.WIDTH,
                              self.HEIGHT])

                pygame.display.flip()#aenderungen anzeigen
                
    def pin(self,x,y, farbe): #einen Pixel printen
         pygame.draw.rect(self.scr,
                             farbe,
                              [(self.MARGIN + self.WIDTH ) * x + self.MARGIN+ self.pos[0],
                              (self.MARGIN + self.HEIGHT) * y + self.MARGIN + self.pos[1],
                              self.WIDTH,
                              self.HEIGHT])#pixel zeichnen

         pygame.display.flip()#aenderungen anzeigen
    def zaehlen(self,counter):#Funktion fuer jeweils ein mal einSchiff der laenge counter klicken
        self.counter=counter
        #klick=0
        while self.done:
            for event in pygame.event.get(): 
            #if event.type == pygame.QUIT: 
            #   done = True 

                if event.type == pygame.MOUSEBUTTONDOWN:#maus geklickt
                    if len(self.info)<self.counter:#wenn schiff nicht schon vollstaendig
                        pos = pygame.mouse.get_pos()#Position der Maus speichern
                        column = (pos[0]- self.pos[0]) // (self.WIDTH + self.MARGIN)#relative position berechnen
                        row = (pos[1] - self.pos[1]) // (self.HEIGHT + self.MARGIN)
                        print("klick, row, column: {}".format((len(self.info),row, column)))#Position in Konsole ausgeben
                        if row>9 or column>9:#falls klick ausserhalb vom Spielfeld
                            return False
                        self.grid[row][column] = self.counter#An diese Position counter einsetzen
          #print("info: "+str(info)
          #info.append([reihe,spalte])#Info ueber das Schiff speichern
          #print("info: "+str(info))
            
                        print("Click ", pos, "Grid coordinates: ", row, column)#Position sowie Koordinaten ausgeben
          #for reihe in range(10):#fuelle das 10x10 Feld je  nach Wert an der Stelle
          # for spalte in range(10):
             
                        self.color = self.new #Pixel rot machen
                        if len(self.schiffe)>4:
                            for x in self.schiffe[4:]:#bereits erstellte Schiffe durchgehen: Pixel bereits besetzt?
                                for y in range (-1,2):#-1 bis 1, 2 exklusive
                                    for z in range (-1,2):
                                        if x.count([row+y,column+z]):#?>0:#pixel und pixel rundherum belegt?
                                            self.color=self.leer#dann aendere nichts

                        if len(self.info)>=1:#wenn pixel bereits im aktuellen schiff
                           print("info:",self.info)
                           for a in self.info:
                                if a==[row,column]:
                                    self.color=self.leer
                           
                    #if x.count([row-1,column])>0 or x.count([row,column-1])>0 or x.count([row+1,column])>0 or x.count([row,column+1])>0:#genau 1 pixel nebenan ist rot
                            # links                             unten                       rechts                  oben ist rot
                                #pixel oder pixel nebenan schon besetzt
                                #self.color=white#pixel weiss machen
              
                        if self.color!=self.leer:#wenn vergleich mit schiffe positiv:
                            self.color=self.leer#neu beginnen      
                            if len(self.info)>0:#nicht der erste klick
                
                           
                                if self.info.count([row-1,column])>0 or self.info.count([row,column-1])>0 or self.info.count([row+1,column])>0 or self.info.count([row,column+1])>0:#genau 1 pixel nebenan ist rot
                            # links                             unten                       rechts                  oben ist rot
                                    if len(self.info)==1:#beim zweiten klick als kreuz
                                        self.color=self.new
        
                                    elif len(self.info)>=2:#beim 3ten klick nur noch vorne oder hinten an reihe anhaengen
                                
                                        for z in range (-1,2,2):
                                            print(z,2*z)
                                            if self.info.count([row,column+z])>0 and self.info.count([row,column+2*z])>0:#2 pixel direkt drueber/drunter 
                                                self.color=self.new
                                            elif self.info.count([row+z,column])>0 and self.info.count([row+2*z,column])>0:#2 pixel direkt rechts/links 
                                                self.color=self.new
                            else:
                                if len(self.info)==0:#beim ersten klick egal
                                    self.color = self.new#dann zum farben markieren
                                    #klick+=1#klick war regelkonform
                                else:
                                    print("Error len(info)")
                                    self.color=self.leer#falls klick kleiner 0/nicht moeglich
             
             
                        if self.color!=self.new:#wenn nicht red gesetzt wurde war der klick nicht regelkonform
                            #print(row,column,0)
                            self.grid[row][column] = 0#inhalt wird zurueckgesetzt
                        else:    
                            print("info: "+str(self.info))
                            self.info.append([row,column])#info ueber schiff speichern
                            print("info: "+str(self.info))
                            print("klick: "+str(len(self.info)))
                            self.printf()
                    
                elif event.type == pygame.KEYDOWN:                
                    if event.key == pygame.K_LEFT:#nach links um letzten pixel zurueckzusetzen
                        print("left")
                        if len(self.info)>0:
                            self.info.pop(len(self.info)-1)
                            self.printf()
                    elif event.key == pygame.K_RETURN:#enter um auswahl zu bestaetigen
                        print("enter")
                        if len(self.info)==self.counter:
                            self.info.insert(0,self.counter)#laenge vor das schiff schreiben
                            self.schiffe.append(self.info)#schiff vollstaendig -> einfuegen
                            print(self.schiffe)
                            self.info=[]#neues Schiff leeren
                            self.printf()
                            #klick=0#klick counter zuruecksetzen
                            self.schiffe[self.counter-2]-=1#speicher, dass ein schiff dieser laenge verbraucht ist
                            self.counter=0#zuruecksetzen
                            return
                   
                   
           
              
           

    def input(self):   
            self.step=1
        #self.reset()
        #while self.done:#solange, wie man das Programm noch laeuft
            for event in pygame.event.get(): 
                if event.type == pygame.QUIT:
                    self.done = False
                    pygame.quit()    
                elif event.type == pygame.KEYDOWN:
                    
                    if event.key ==pygame.K_a:#wenn a gedrueckt wird kann man das schiffsarray direkt eingeben
                        self.done=False
                        eingabe=input("Deine Schiffe:")
                        eingabe.rsplit("],[")[0]#string zu array machen
                        self.inputa(eingabe)
                        return True
                    elif event.key==pygame.K_5:#Tastenanschlag 5
                        if self.schiffe[3]!=0:#Wenn noch ein Schiff der laenge frei ist
                            
                            self.zaehlen(5)#Schiff der lange 5 klicken koennen
                            #schiffe[3]-=1#speicher, dass ein schiff dieser laenge verbraucht ist
                    elif event.key==pygame.K_4:
                        if self.schiffe[2]!=0:
                            
                            self.zaehlen(4)
                            #schiffe[2]-=1
                    elif event.key==pygame.K_3:
                        if self.schiffe[1]!=0:
                            
                            self.zaehlen(3)
                            #schiffe[1]-=1
                    elif event.key==pygame.K_2:  
                        if self.schiffe[0]!=0:
                            
                            self.zaehlen(2)
                            #schiffe[0]-=1
                    #elif event.type == pygame.QUIT: 
                    #done = True 
                    if self.schiffe[0:4]==[0,0,0,0]:#wenn alle schiffe gesetzt sind
                        self.step=2
                        self.printf()
                        return self.schiffe#input fertig
            return False#nichts passiert
    def inputa(self,array):
            self.schiffe.append(array)
            for x in array:
                self.schiffe.append(x)
                spiel.grid[x[0]][x[1]]=1
    def zug(self):
            self.counter=-1
            safe=None
            self.printf()
         #while self.done:
            for event in pygame.event.get(): 
            #if event.type == pygame.QUIT: 
            #   done = True 
                
                if event.type == pygame.MOUSEBUTTONDOWN:#maus geklickt
                        if safe!=None:#wenn ein zweiter klick passiert
                            self.pin(row,column,self.leer)  #vorherigen loeschen
                        pos = pygame.mouse.get_pos()#Position der Maus speichern
                        column = (pos[0]- self.pos[0]) // (self.WIDTH + self.MARGIN)#relative position berechnen
                        row = (pos[1] - self.pos[1]) // (self.HEIGHT + self.MARGIN)
                        if row>10 or column>10:#klick nicht in spielfeld
                            return False
                        print("klick, row, column: {}".format((len(self.info),row, column)))#Position in Konsole ausgeben
                        if self.grid[row][column]>=0:#wenn noch nicht abgeschossen, neuen klick merken
                            safe=row,column,self.grid[row][column]#pixel infos speichern
                            for x in safe:
                                print(x)
                       
                            print("Click ", pos, "Grid coordinates: ", row, column)#Position sowie Koordinaten ausgeben
         
                            self.pin(row,column,self.new)  #pixel markieren

                elif event.type == pygame.QUIT:
                    self.done = False
                    pygame.quit()        
                    
                elif event.type == pygame.KEYDOWN:                
                    if event.key == pygame.K_LEFT:#nach links um letzten pixel zurueckzusetzen
                        if safe!=None:#es gibt einen klick zum zurueckgehen
                            self.pin(row,column,self.leer)#aktuellen pixel zurueckfaerben
                            self.grid[row][column]=safe[2]#infos resetten 
                           
                    elif event.key == pygame.K_RETURN:#enter um auswahl zu bestaetigen

                       if safe!=None:#der klick wurde bestaetigt
                        if self.hits>=self.leben:#alle schiffe getroffen
                            self.printf()
                            print(self.grid)
                            print(repr(self.grid))
                            return "win"
                        print("enter")
                        self.zuege+=1
                        self.color = self.miss #Pixel als daneben markieren
                        self.grid[safe[0]][safe[1]] = -2# miss eintragen
                        if len(self.schiffe)>4:#mind. ein Pixel grosses schiff vorhanden
                            for x in self.schiffe[4:]:#die einzelnen schiffe durchgehen
                                if x.count([safe[0],safe[1]])>0:#pixel besetzt -> treffer
                                    self.grid[safe[0]][safe[1]] = -1#hit eintragen
                                    print(self.grid)
                                    
                                    self.hits+=1
                                    self.color=self.hit
                                    #getroffene schiffe mit 0 markieren
                                    
                                    x[0]-=1#ein element des schiffes getroffen
                                    if x[0]==0:#komplettes schiff getroffen
                                        for y in x[1:]:#alle elemente des schiffs
                                            self.pin(y[0],y[1],self.right)#blau faerben

                                        self.color=self.right
                        self.pin(row,column,self.color)#ergebnis printen
                        print("Zug: {}, Hits: {}".format(self.zuege,self.hits))
                        safe=None#pixel infos resetten      
                        if self.color==self.miss:#daneben zu vorbei
                            return self.schiffe#zug beendet
                        else:#sonst noch ein versuch
                            return False
                        
                    elif event.key == pygame.K_ESCAPE:#schliessen
                        
                        print("esc")
                        self.exit()
                        return "exit"
          
                        
                    elif event.key == pygame.K_SPACE:#schliessen
                        
                        print("SPACE")
                        self.exit()
                        return "exit"
            return False#nichts passiert
class singleplayer(spiel):#ohne input()
    def __init__(self):
        self.name="Spieler1"
       
        self.player=game(self.name)
    def start(self):
        self.player.start()
         
    def zug(self):
        run=1
        while (run != "win" and run !="exit"):
            run=self.player.zug()
            if run =="exit":
                
                self.player.remove(x)
            if run=="win":
                print("Congratulations "+self.name+". \nYou won in "+str(self.player.zuege)+"steps!!!")
            
        eingabe=input("again?: y/n")
        if eingabe.upper()==Y:
            self.start()

"""
beispiel grid:

[[2 2 0 2 2 0 2 2 0 0]
 [0 0 0 0 0 0 0 0 0 0]
 [3 3 3 0 3 3 3 0 0 0]
 [0 0 0 0 0 0 0 0 0 0]
 [4 4 4 4 0 4 4 4 4 0]
 [0 0 0 0 0 0 0 0 0 0]
 [0 0 0 0 0 0 0 0 0 0]
 [0 0 5 5 5 5 5 0 0 0]
 [0 0 0 0 0 0 0 0 2 0]
 [0 3 3 3 0 0 0 0 2 0]]

beispiel schiffe:

[0, 0, 0, 0, [[0, 0], [0, 1]], [[0, 3], [0, 4]], [[0, 6], [0, 7]], [[2, 0], [2, 1], [2, 2]], [[2, 4], [2, 5], [2, 6]], [[4, 0], [4, 1], [4, 2], [4, 3]], [[4, 5], [4, 6], [4, 7], [4, 8]], [[7, 3], [7, 2], [7, 4], [7, 5], [7, 6]], [[8, 8], [9, 8]], [[9, 1], [9, 2], [9, 3]]]

"""




#Heute:

#buttons



#newGame

#multiplayer:
#fehler beim schliessen beheben(ship)
#while schleifen in client erweitern und aus multi rausmachen
#jeden einzelnen klick zerhackstueckeln und return (grid/ schiffe)
#multiplayer ermoeglichen (socket)
#zuschauen: selbst gesetzte schiffe sehen und vom gegner anvisierte
#gegnerische zuege anzeigen

#---
#quit = quit (kreuz)
#anfang auswahl singleplayer/multiplayer
#zurueck button/ esc
#singleplayer:
#lokal
#zufaelliges spielfeld: random pixel danach brute forse immer eins weiter in eine richtung, 4 richtungen, sonst naechsten pixel
#---





#Donnerstag
#jupyter notebook dokumentation/vortrag
#auf master hosten
#exen

#praesentation:
#erst multiplayer bis swap
#dann singleplayer ohne input
#dann code: server/client/multi

#---
#alles schoen machen
#auf website hochladen

#difficultie: medium: schiff versenkt/treffer-> alle pixel im umkreus markiert(miss), was nicht mehr geht
#light: pixel im umkreis von schuss aufgedeckt
#---