class Game:
    def __init__(self, id):
        self.p1Went = False
        self.p2Went = False
        self.ready = False
        self.id = id
        self.moves = [0,0]
        self.wins = [0,0]
        self.ties = 0
        self.swap=False

    def get_player_move(self, p):
        """
        :param p: [0,1]
        :return: Move
        """
        return self.moves[p]

    def play(self, player, move):
        self.moves[player] = move
        if player == 0:
            self.p1Went = True
           
        else:
            self.p2Went = True
            
    def connected(self):
        return self.ready

    def bothWent(self):
        return self.p1Went and self.p2Went

    def swap(self):
        if self.swap:
            safe=self.moves[0]
            self.moves[0]=self.moves[1]
            self.moves[1]=safe



    def winner(self, p):

        p1 = self.moves[0].lower()[0]
        p2 = self.moves[1].lower()[0]

        winner=p#aktueller spieler hat gewonnen
        if p2 == p1:#anderer spieler hat auch gewonnen
            winner=-1#unentschieden
            
        return winner

    def resetWent(self):
        self.p1Went = False
        self.p2Went = False
        self.moves[0]=0
        self.moves[1]=0
        