import socket
from _thread import *
import pickle
from player import Game

server = "localhost"
port = 5555

s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)

try:
    s.bind((server, port))#verbindung an port aufbauen
except socket.error as e:
    str(e)

s.listen(2)#port oeffnen
print("Waiting for a connection, Server Started")

connected = set()
games = {}
idCount = 0


def threaded_client(conn, p, gameId):#mit client code kommunizieren
    global idCount
    conn.send(str.encode(str(p)))#spieler1/2? an client senden

    reply = ""
    while True:
        try:
            data = conn.recv(4096).decode()#infos vom client empfangen

            if gameId in games:#wenn game vorhanden
                game = games[gameId]#aktuelles game raussuchen

                if not data:
                    break
                else:#wenn infos vorhanden
                    if data == "reset":#wenn reset gesendet wurde
                        game.resetWent()#zug wurde ausgefuehrt, neuer kann beginnen
                    elif data== "win":
                        game.moves[p]=="win"
                        game.winner(p)
                    elif data=="swap":#nach input werden die spiele vertauscht
                        game.swap()
                    elif data != "update":#spieler hat zug gemacht
                        game.play(p, data)#info abspeichern
                   
                    

                    conn.sendall(pickle.dumps(game))#game objekt an clients senden
            else:
                break
        except:
            break

    print("Lost connection")
    try:#keine verbindung mehr
        del games[gameId]#spiel loeschen falls noch vorhanden
        print("Closing Game", gameId)
    except:
        pass
    idCount -= 1#ein spieler weniger
    conn.close()#socket verbindung schliessen



while True:#auf verbindungen warten
    conn, addr = s.accept()#client angemeldet
    print("Connected to:", addr)

    idCount += 1#ein spieler mehr
    p = 0#spieler 1
    gameId = (idCount - 1)//2#zugehoeriges spiel je nach spieleranzahl
    if idCount % 2 == 1:#spieleranzahl ungerade
        games[gameId] = Game(gameId)#neues spiel muss erstellt werden
        print("Creating a new game...")
    else:
        games[gameId].ready = True#spiel voll besetzt
        p = 1#spieler 2


    start_new_thread(threaded_client, (conn, p, gameId))#neuen client starten