import pygame
import numpy as np
class game(object):
    def __init__(self, spieler):
        self.name=spieler
        self.black = (0, 0, 0)
        self.white = (255, 255, 255)
        self.yellow= (0,255,255)
        self.red = (255, 0, 0)
        self.blue=(255,255,0)
        self.green=(255,0,255)
        self.miss=self.yellow
        self.new=self.red
        self.leer=self.white
        self.right=self.blue
        self.hit=self.black
        self.WIDTH = 20
        self.HEIGHT = 20
        self.MARGIN = 5
        self.hits=0#getroffene Pixel
        self.zuege=0#gebrauchte zuege
        self.schiffe=[4,3,2,1]#Anzahl der Schiffe von 2-5
        self.leben=0
        
        self.grid = []
        self.grid=np.zeros([10,10],dtype="int") #10x10 array mit nullen
    def start(self):
       
        
        for x in range(4):
            self.leben+=(x+2)*self.schiffe[x]#anzahl der benoetigten treffer bestimmen
        pygame.init()#pygame starten
        self.window_size = [255, 255]#feldgroesse initiieren
        self.scr = pygame.display.set_mode(self.window_size)#pygame feld der groesse starten
        pygame.display.set_caption("Schiffe versenken")#ueberschrift andern
        self.done = True
        #pygame.time.Clock()#verzoegern
        self.reset()
        if len(self.schiffe)<=4:#wenn schiffe nicht beim initialisieren eingegeben wurden
            self.input()
            
            print(repr(self.grid))
            print(self.schiffe)
        self.reset()
        ergebnis=self.zug()
        if ergebnis=="win":
            self.right=self.green
            self.printf
            print("Congratulations "+self.name+". \nYou won in "+str(self.zuege)+" steps!!!")
            self.right=self.blue
        elif ergebnis=="exit":
            print("Spieler hat das Spiel beendet")
        else:
            print("Unerwarteter Fehler:"+str(ergebnis))
        """    
        eingabe=input("again?: y/n")
        if eingabe.upper()==Y:
            self.start()"""
    def exit(self):
        pygame.quit()
        self.done=False
    def reset(self):#das grid zeichnen
        self.scr.fill(self.black)#feld mit schwarz fuellen 
        self.info=[]#infos ueber das aktuell geklickte schiff
        for row in range(10):#kaestchen malen
            for column in range(10):
                pygame.draw.rect(self.scr,
                             self.leer,
                             [(self.MARGIN + self.WIDTH) * column + self.MARGIN,
                              (self.MARGIN + self.HEIGHT) * row + self.MARGIN,
                              self.WIDTH,
                              self.HEIGHT])

        pygame.display.flip()
    def printf(self):

        for row in range(10):#kaestchen malen
            for column in range(10):
                self.color=self.leer#kein schiff
                if self.info.count([row,column])>0:
                    self.color=self.new#neues schiff
                for z in self.schiffe[4:]:
                    if z.count([row,column])>0:
                        self.color=self.right#fertiges schiff
          
                pygame.draw.rect(self.scr,
                             self.color,
                             [(self.MARGIN + self.WIDTH) * column + self.MARGIN,
                              (self.MARGIN + self.HEIGHT) * row + self.MARGIN,
                              self.WIDTH,
                              self.HEIGHT])#pixel zeichnen

                pygame.display.flip()#aenderungen anzeigen
    def pin(self,x,y, farbe): #einen Pixel printen
         pygame.draw.rect(self.scr,
                             farbe,
                             [(self.MARGIN + self.WIDTH) * y + self.MARGIN,
                              (self.MARGIN + self.HEIGHT) * x + self.MARGIN,
                              self.WIDTH,
                              self.HEIGHT])#pixel zeichnen

         pygame.display.flip()#aenderungen anzeigen
    def zaehlen(self,counter):#Funktion fuer jeweils ein mal einSchiff der laenge counter klicken
        self.counter=counter
        #klick=0
        while self.done:
            for event in pygame.event.get(): 
            #if event.type == pygame.QUIT: 
            #   done = True 

                if event.type == pygame.MOUSEBUTTONDOWN:#maus geklickt
                    if len(self.info)<self.counter:#wenn schiff nicht schon vollstaendig
                        pos = pygame.mouse.get_pos()#Position der Maus speichern
                        column = pos[0] // (self.WIDTH + self.MARGIN)#relative position berechnen
                        row = pos[1] // (self.HEIGHT + self.MARGIN)
                        print("klick, row, column: {}".format((len(self.info),row, column)))#Position in Konsole ausgeben
                        if row>9 or column>9:#falls klick ausserhalb vom Spielfeld
                            return False
                        self.grid[row][column] = self.counter#An diese Position counter einsetzen
          #print("info: "+str(info)
          #info.append([reihe,spalte])#Info ueber das Schiff speichern
          #print("info: "+str(info))
            
                        print("Click ", pos, "Grid coordinates: ", row, column)#Position sowie Koordinaten ausgeben
          #for reihe in range(10):#fuelle das 10x10 Feld je  nach Wert an der Stelle
          # for spalte in range(10):
             
                        self.color = self.new #Pixel rot machen
                        if len(self.schiffe)>4:
                            for x in self.schiffe[4:]:#bereites erstellte Schiffe durhgehen: Pixel bereits besetzt?
                                for y in range (-1,2):#-1 bis 1, 2 exklusive
                                    print(y)
                                    for z in range (-1,2):
                                        if x.count([row+y,column+z]):#?>0:#pixel und pixel rundherum belegt?
                                            self.color=self.leer#dann �ndere nichts
                           
                    #if x.count([row-1,column])>0 or x.count([row,column-1])>0 or x.count([row+1,column])>0 or x.count([row,column+1])>0:#genau 1 pixel nebenan ist rot
                            # links                             unten                       rechts                  oben ist rot
                                #pixel oder pixel nebenan schon besetzt
                                #self.color=white#pixel weiss machen
              
                        if self.color!=self.leer:#wenn vergleich mit schiffe positiv:
                            self.color=self.leer#neu beginnen      
                            if len(self.info)>0:#nicht der erste klick
                
                           
                                if self.info.count([row-1,column])>0 or self.info.count([row,column-1])>0 or self.info.count([row+1,column])>0 or self.info.count([row,column+1])>0:#genau 1 pixel nebenan ist rot
                            # links                             unten                       rechts                  oben ist rot
                                    if len(self.info)==1:#beim zweiten klick als kreuz
                                        self.color=self.new
        
                                    elif len(self.info)>=2:#beim 3ten klick nur noch vorne oder hinten an reihe anhaengen
                                
                                        for z in range (-1,2,2):
                                            print(z,2*z)
                                            if self.info.count([row,column+z])>0 and self.info.count([row,column+2*z])>0:#2 pixel direkt drueber/drunter 
                                                self.color=self.new
                                            elif self.info.count([row+z,column])>0 and self.info.count([row+2*z,column])>0:#2 pixel direkt rechts/links 
                                                self.color=self.new
                            else:
                                if len(self.info)==0:#beim ersten klick egal
                                    self.color = self.new#dann zum farben markieren
                                    #klick+=1#klick war regelkonform
                                else:
                                    print("Error len(info)")
                                    self.color=self.leer#falls klick kleiner 0/nicht moeglich
             
             
                        if self.color!=self.new:#wenn nicht red gesetzt wurde war der klick nicht regelkonform
                            #print(row,column,0)
                            self.grid[row][column] = 0#inhalt wird zurueckgesetzt
                        else:    
                            print("info: "+str(self.info))
                            self.info.append([row,column])#info ueber schiff speichern
                            print("info: "+str(self.info))
                            print("klick: "+str(len(self.info)))
                            self.printf()
                elif event.type == pygame.QUIT:
                    print("quit")
                    self.exit()
                    return "exit"
                elif event.type == pygame.KEYDOWN:                
                    if event.key == pygame.K_LEFT:#nach links um letzten pixel zurueckzusetzen
                        print("left")
                        if len(self.info)>0:
                            self.info.pop(len(self.info)-1)
                            self.printf()
                    elif event.key == pygame.K_RETURN:#enter um auswahl zu bestaetigen
                        print("enter")
                        if len(self.info)==self.counter:
                            self.info.insert(0,self.counter)#laenge vor das schiff schreiben
                            self.schiffe.append(self.info)#schiff vollstaendig -> einfuegen
                            self.info=[]#neues Schiff leeren
                            self.printf()
                            #klick=0#klick counter zuruecksetzen
                            self.schiffe[self.counter-2]-=1#speicher, dass ein schiff dieser laenge verbraucht ist
                            self.counter=0#zuruecksetzen
                            return
                    elif event.key == pygame.K_ESCAPE:#schliessen
                        
                        print("esc")
                        
                        self.exit()#spiel beenden
                        return "exit"
                    elif event.key == pygame.K_SPACE:#schliessen
                        
                        print("SPACE")
                        self.exit()
            
                        return "exit"
                   
           
              
           

    def input(self):   
        while self.done:#solange, wie man das Programm noch laeuft
            for event in pygame.event.get(): 
                if event.type == pygame.QUIT:
                    self.done = False
                    pygame.quit()   
                elif event.type == pygame.KEYDOWN:
                    if event.key == pygame.K_ESCAPE:
                        
                        print("esc")
                        self.exit()
                        return "exit"
                    elif event.key == pygame.K_SPACE:
                        
                        print("SPACE")
                        self.exit()
                        return "exit"
                    elif event.key ==pygame.K_a:#wenn a gedr�ckt wird kann man das schiffsarray direkt eingeben
                        self.done=False
                        eingabe=input("Deine Schiffe:")
                        eingabe.rsplit("],[")[0]#string zu array machen
                        self.inputa(eingabe)
                        return 
                    elif event.key==pygame.K_5:#Tastenanschlag 5
                        if self.schiffe[3]!=0:#Wenn noch ein Schiff der laenge frei ist
                            
                            self.zaehlen(5)#Schiff der lange 5 klicken koennen
                            #schiffe[3]-=1#speicher, dass ein schiff dieser laenge verbraucht ist
                    elif event.key==pygame.K_4:
                        if self.schiffe[2]!=0:
                            
                            self.zaehlen(4)
                            #schiffe[2]-=1
                    elif event.key==pygame.K_3:
                        if self.schiffe[1]!=0:
                            
                            self.zaehlen(3)
                            #schiffe[1]-=1
                    elif event.key==pygame.K_2:  
                        if self.schiffe[0]!=0:
                            
                            self.zaehlen(2)
                            #schiffe[0]-=1
                    #elif event.type == pygame.QUIT: 
                    #done = True 
                    if self.schiffe[0:4]==[0,0,0,0]:#wenn alle schiffe gesetzt sind
                        return
    def inputa(self,array):
            self.schiffe.append(array)
            for x in array:
                self.schiffe.append(x)
                spiel.grid[x[0]][x[1]]=1
    def zug(self):
         self.counter=-1
         safe=None
         while self.done:
            for event in pygame.event.get(): 
            #if event.type == pygame.QUIT: 
            #   done = True 
                
                if event.type == pygame.MOUSEBUTTONDOWN:#maus geklickt
                        if safe!=None:#wenn ein zweiter klick passiert
                            self.pin(row,column,self.leer)  #vorherigen loeschen
                        pos = pygame.mouse.get_pos()#Position der Maus speichern
                        column = pos[0] // (self.WIDTH + self.MARGIN)#relative position berechnen
                        row = pos[1] // (self.HEIGHT + self.MARGIN)

                        print("klick, row, column: {}".format((len(self.info),row, column)))#Position in Konsole ausgeben
                        if self.grid[row][column]>=0:#wenn noch nicht abgeschossen, neuen klick merken
                            safe=row,column,self.grid[row][column]#pixel infos speichern
                            for x in safe:
                                print(x)
                        
                            print("Click ", pos, "Grid coordinates: ", row, column)#Position sowie Koordinaten ausgeben
         
                            self.pin(row,column,self.new)  #pixel markieren

                            
                elif event.type == pygame.QUIT:
                    print("quit")
                    self.exit()
                    return "exit"   
                elif event.type == pygame.KEYDOWN:                
                    if event.key == pygame.K_LEFT:#nach links um letzten pixel zurueckzusetzen
                        if safe!=None:#es gibt einen klick zum zurueckgehen
                            self.pin(row,column,self.leer)#aktuellen pixel zurueckfaerben
                            self.grid[row][column]=safe[2]#infos resetten 
                           
                    elif event.key == pygame.K_RETURN:#enter um auswahl zu bestaetigen
                       if safe!=None:#der klick wurde bestaetigt
                        print("enter")
                        self.zuege+=1
                        self.color = self.miss #Pixel als daneben markieren
                        self.grid[safe[0]][safe[1]] = -2# miss eintragen
                        if len(self.schiffe)>4:#mind. ein Pixel grosses schiff vorhanden
                            for x in self.schiffe[4:]:#die einzelnen schiffe durchgehen
                                if x.count([safe[0],safe[1]])>0:#pixel besetzt -> treffer
                                    self.grid[safe[0]][safe[1]] = -1#hit eintragen
                                    print(self.grid)
                                    
                                    self.hits+=1
                                    self.color=self.hit
                                    #getroffene schiffe mit 0 markieren
                                    
                                    x[0]-=1#ein element des schiffes getroffen
                                    if x[0]==0:#komplettes schiff getroffen
                                        for y in x[1:]:#alle elemente des schifs
                                            self.pin(y[0],y[1],self.right)#blau faerben

                                        self.color=self.right
                        self.pin(row,column,self.color)#ergebnis printen
                        print("Zug: {}, Hits: {}".format(self.zuege,self.hits))
                        safe=None#klock infos resetten
                        if self.hits>=self.leben:
                            font = pygame.font.SysFont("comicsans", 40)
                            self.printf()
                            print(self.grid)
                            print(repr(self.grid))
                            text = font.render("won in "+str(self.zuege), 1, (255, 0, 0))
                            
                            self.scr.blit(text, (self.window_size[0]/2 - text.get_width()/2, self.window_size[1]/2 - text.get_height()/2))            
                            pygame.display.update()
                            pygame.time.delay(5000)#text 5 sekunden anzeigen
                            #self.printf()
                            return "win"#danach sollte es nicht schliessen
                        return self.zug()
                        
                    elif event.key == pygame.K_ESCAPE:#schliessen
                        
                        print("esc")
                        self.exit()
                        return "exit"
          
                        
                    elif event.key == pygame.K_SPACE:#schliessen
                        
                        print("SPACE")
                        self.exit()
                        return "exit"

class singleplayer(game):#ohne input()
    def __init__(self):
        self.name="Spieler1"
       
        self.player=game(self.name)
    def start(self):
        self.player.start()
         
    def zug(self):
        run=1
        while (run != "win" and run !="exit"):
            run=self.player.zug()
            if run =="exit":
                
                self.player.remove(x)
            if run=="win":
                print("Congratulations "+self.name+". \nYou won in "+str(self.player.zuege)+"steps!!!")
                self.start()
                
        """    
        eingabe=input("again?: y/n")
        if eingabe.upper()==Y:
            self.start()"""
def starte(modus):
    
        #if modus=="singleplayer":
        spiel=game("spieler")
        """input=[4, [2,4],[3,4],[4,4],[5,4]]
           for x in input:
            spiel.schiffe.append(x)
            spiel.grid[x[0]][x[1]]=4"""#moegliche eingabe ohne self.input()
        #spiel.schiffe=[4, 3, 2, 1, [2, [0, 0], [0, 1]], [2, [0, 3], [0, 4]], [2, [0, 6], [0, 7]], [3, [2, 0], [2, 1], [2, 2]], [3, [2, 4], [2, 5], [2, 6]], [4, [4, 0], [4, 1], [4, 2], [4, 3]], [4, [4, 5], [4, 6], [4, 7], [4, 8]], [5, [7, 3], [7, 2], [7, 4], [7, 5], [7, 6]], [2, [8, 8], [9, 8]], [3, [9, 1], [9, 2], [9, 3]]]
        spiel.schiffe=[1,0,0,1,[2,[0,0],[0,1]],[5,[9,9],[8,9],[7,9],[6,9],[5,9]]]#auskommentieren, falls man nur versenken will
        #print(spiel.schiffe)
        #print(spiel.schiffe[5])
        spiel.start()

        #spiel.input()
        #spiel.zug()

        if modus=="multiplayer":
            #do networking
            pass

starte("singleplayer")
#auswahl()
"""
beispiel grid:

[[2 2 0 2 2 0 2 2 0 0]
 [0 0 0 0 0 0 0 0 0 0]
 [3 3 3 0 3 3 3 0 0 0]
 [0 0 0 0 0 0 0 0 0 0]
 [4 4 4 4 0 4 4 4 4 0]
 [0 0 0 0 0 0 0 0 0 0]
 [0 0 0 0 0 0 0 0 0 0]
 [0 0 5 5 5 5 5 0 0 0]
 [0 0 0 0 0 0 0 0 2 0]
 [0 3 3 3 0 0 0 0 2 0]]

beispiel schiffe:

[0, 0, 0, 0, [[0, 0], [0, 1]], [[0, 3], [0, 4]], [[0, 6], [0, 7]], [[2, 0], [2, 1], [2, 2]], [[2, 4], [2, 5], [2, 6]], [[4, 0], [4, 1], [4, 2], [4, 3]], [[4, 5], [4, 6], [4, 7], [4, 8]], [[7, 3], [7, 2], [7, 4], [7, 5], [7, 6]], [[8, 8], [9, 8]], [[9, 1], [9, 2], [9, 3]]]

"""



#Heute:

#buttons

#anfang auswahl singleplayer/multiplayer
#zurueck button

#multiplayer:
#normal plus network
#multiplayer ermoeglichen (socket)

#singleplayer:
#lokal
#zufaelliges spielfeld: random pixel danach brute forse immer eins weiter in eine richtung, 4 richtungen, sonst naechsten pixel


#newGame

#Donnerstag
#jupyter notebook dokumentation/vortrag
#auf master hosten
#exen

#alles schoen machen
#auf website hochladen

#difficultie: medium: schiff versenkt/treffer-> alle pixel im umkreus markiert(miss), was nicht mehr geht
#light: pixel im umkreis von schuss aufgedeckt